<html id="web"><title>How to build a simple website with <code>ssg5</code> &mdash; Stefanos blog</title>
<meta charset="UTF-8">
<link rel="alternate" type="application/atom+xml" href="/rss.xml">
<link rel="stylesheet" href="/style.css">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<script src="https://code.jquery.com/jquery-3.6.0.slim.min.js" integrity="sha256-u7e5khyithlIdTpu22PHhENmPcRdFiHRjhAuHcs05RI=" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/js-cookie@rc/dist/js.cookie.min.js"></script>
<script src="/n.js"></script>
<link href="https://fonts.googleapis.com/css2?family=Inconsolata:wght@400&family=Questrial&display=swap" rel="stylesheet">
<link href="https://fonts.googleapis.com/css2?family=Quicksand:wght@400&display=swap" rel="stylesheet">
<!--<script type = "text/javascript">  
window.onload = function() {
    var pre = document.getElementsByTagName('pre'),
        pl = pre.length;
    for (var i = 0; i < pl; i++) {
        pre[i].innerHTML = '<span class="line-number"></span>' + pre[i].innerHTML + '<span class="cl"></span>';
        var num = pre[i].innerHTML.split(/\n/).length;
        for (var j = 0; j < num; j++) {
            var line_num = pre[i].getElementsByTagName('span')[0];
            line_num.innerHTML += '<span>' + (j + 1) + '</span>';
        }
    }
};-->
</script>
<div class="topbar">
	<div class="logo-container">
		<img src="https://gitlab.com/stefano.cadringher/cadri.xyz/-/raw/master/common/images/logo.svg" height="100%">
	</div>
	<div class="menuitem">
		<a class="m" href="/index.html">Home</a>
	</div>
	<div class="menuitem">
		<a class="m" href="/contacts.html">@me</a>
	</div>
	<div class="menuitem">
		<a class="m" href="/articles.html">Blog</a>
	</div>
	<div class="menuitem">
		<a class="m" href="/experience.html">Work</a>
	</div>
</div>
<h1>How to build a simple website with <code>ssg5</code></h1>

<h3><a class=backbtn href=/articles>← Previous page</a></h3>

<p><em>Last updated Mer  2 Mar 2022 12:42:01 CET</em></p>

<blockquote>
  <p>I was inspired to rebuild my website by <a href="https://www.youtube.com/watch?v=N_ttw2Dihn8">This video</a> from one of my favorite content creators. If you want a complete look into <code>ssg5</code> <strong>I suggest going to the creator's website</strong>, linked down below in the footer. </p>
</blockquote>

<h2>Basic knowledge</h2>

<p><code>ssg5</code> when combined with <a href="https://kristaps.bsd.lv/lowdown/">lowdown</a> or <a href="https://daringfireball.net/projects/markdown/">Markdown.pl</a> essentially <em>compiles</em> your easy to write <a href="https://en.wikipedia.org/wiki/Markdown">markdown</a> file into an HTML file, appending the precompiled header footer at the top and bottom of the page, and applying the <code>style.css</code> that can be placed be in the <code>src</code> folder.</p>

<h2>Installation</h2>

<h3>Download</h3>

<pre><code>mkdir -p bin 
curl -s https://rgz.ee/bin/ssg5 > bin/ssg5
curl -s https://rgz.ee/bin/Markdown.pl > bin/Markdown.pl
chmod +x bin/ssg5 bin/Markdown.pl</code></pre>

<p>For this installation we are going to use <code>Markdown.pl</code> because we want to convert <code>.md</code> files into HTML files.</p>

<h3>Setup and test run</h3>

<p>Now we need to make sure that both <code>ssg5</code> and <code>Markdown.pl</code> are in <code>$PATH</code>, and to create the source <code>src</code> folder and the destination <code>dst</code> folder. You can call these folders however you want. I renamed my <code>dst</code> folder <code>web</code>, for example.</p>

<pre><code>PATH="wherever/your/bin/is:$PATH"
mkdir src dst</code></pre>

<p>Now we need to populate the <code>src</code> folder wit actual markdown source. To do this simply put something markdown into an <code>index.md</code> located in <code>src</code></p>

<p><img src="/images/index-markdown-new.png" alt="index.md example" title="index.md example" /></p>

<p>An header and a footer need to be added to the <code>src</code> folder in order to link a css file, add a navbar and whatever you do with headers and footers. To do this we have to create a file called <code>_header.html</code> and a file called <code>_footer.html</code></p>

<h4>My <code>_header.html</code> file:</h4>

<pre><code><&zwj;html id="web"><&zwj;title><&zwj;/title>
<&zwj;meta charset="UTF-8">
<&zwj;link rel="alternate" type="application/atom+xml" href="/rss.xml">
<&zwj;link rel="stylesheet" href="/style.css">
<&zwj;meta name="viewport" content="width=device-width, initial-scale=1.0">
<&zwj;script src="https://code.jquery.com/jquery-3.6.0.slim.min.js" integrity="sha256-u7e5khyithlIdTpu22PHhENmPcRdFiHRjhAuHcs05RI=" crossorigin="anonymous"><&zwj;/script>
<&zwj;script src="https://cdn.jsdelivr.net/npm/js-cookie@rc/dist/js.cookie.min.js"><&zwj;/script>
<&zwj;script src="/n.js"><&zwj;/script>
<&zwj;link href="https://fonts.googleapis.com/css2?family=Inconsolata:wght@300&family=Questrial&display=swap" rel="stylesheet">
<&zwj;link href="https://fonts.googleapis.com/css2?family=Quicksand:wght@300&display=swap" rel="stylesheet">
...</code></pre>

<h4>My <code>_footer.html</code> file:</h4>

<pre><code><&zwj;div class="footer">
    <&zwj;div class="menuitem">
        <&zwj;a class="m" href="https://it.cadri.xyz">🇮🇹 in Italiano<&zwj;/a> 
        <&zwj;a class="m" style="cursor: pointer;"onclick="toggleNightMode()">✨ Night Mode<&zwj;/a> 
    <&zwj;/div>
    <&zwj;br><&zwj;br>
    &copy; <&zwj;a href="contacts.html">Stefano Cadringher<&zwj;/a> @ Nacheso Software, 2021 &mdash; VAT: 11328220964<&zwj;br>
    Powered by a modified version of <&zwj;a href="https://www.romanzolotarev.com">Roman Zolotarev's<&zwj;/a> <&zwj;a href="https://www.romanzolotarev.com/ssg.html">ssg5<&zwj;/a>
<&zwj;/div>
...</code></pre>

<p>Now you just need to run <code>ssg5</code> with this command</p>

<pre><code>
bin/ssg5 src dst 'Test' 'http://www.yourwebsite.com'
</code></pre>

<p>Where <code>bin</code> is the folder you have <code>ssg5</code> in, <code>src</code> is where you put all your <code>.md</code> files, and <code>dst</code> is the destination folder, where all yout HTML file will go. <strong>Test</strong> is the name of the website, and will appear after the name of the page on your browser's tab. You can change that to whatever you want. <strong>The last parameter is required</strong> if you want rss feeds (not covered here) and the <code>sitemap.xml</code> automatically generated by <code>ssg5</code>. What I run for this website for example is</p>

<pre><code>
bin/ssg5 src web 'Stefanos blog' 'https://en.cadri.xyz'
</code></pre>

<p><img src="/images/dst-folder-finder.png" alt="alt text" title="index.md example" /></p>

<h2>Final touches</h2>

<p>We have a page. Great. Now I'm going to explain how I started from there and <strong>built this website</strong>. I needed a higher level of complexity since I was going to write these articles in two languages and <strong>I wanted to share static content between html pages of both languages</strong>, though keeping the number of folders on the server as low as possible.</p>

<h3>Folder structure</h3>

<p><img src="/images/folder-file-list.png" alt="alt text" title="index.md example" /></p>

<p>My solution is very simple as didn't require much effort to make. I started putting everything that I wanted to be shared between the two different websites (I have them as different <em>virtual servers</em> on nginx) in the <code>common</code> folder. I then wrote a script to run <code>ssg5</code> on the <code>it</code> and <code>en</code> folders, like this:</p>

<pre><code>#!/bin/zsh
PATH="$HOME/Documents/htdocs/Website/bin:$PATH"
cd ..

./bin/ssg5 en/src en/web 'Stefanos blog' 'https://en.cadri.xyz' &> /dev/null
cp -R common/* en/web/

#   compilo l'ultima versione del CV e la copio
/./Users/stefano/Documents/CV/compile.sh
cp /Users/stefano/Documents/CV/EN/StefanoCadringherEN.pdf common/StefanoCadringherEN.pdf
echo "(✓) Curriculum compilato e copiato.    "

echo -e "\e[1mModifiche apportate:\e[0m"
echo "${$({ git diff --name-only ; git diff --name-only --staged ; } | sort | uniq)/ /\n • }"

echo "\n.. Aggiorno la repository... "
git add . &> /dev/null
git commit -m "update $(date)" &> /dev/null
git push -u origin master &> /dev/null
tput cuu1
tput cuu1
echo "(✓) Repository aggiornata.    "
git log --pretty=format:"%H - %an" | head -n 1
tput cud1

if [ "$1" != "--update-repository" ]; then
    surge it/web it.cadri.xyz
    surge en/web en.cadri.xyz
    surge default cadri.xyz
fi</code></pre>

<p>As you can see I compile my website from the <code>src</code> folder for every language and put all my media content directly in the <code>web</code> folder, where the finished HTML files are. Before uploading I compile my LaTeX resume and put it in the correct <code>common</code> folder with the right name. I then <code>git diff</code> to display all the files that have been modified and are ready to get committed. The program then pushes the files to a <a href="https://gitlab.com/stefano.cadringher/cadri.xyz">public repository</a> where I can keep track of my changes. I use <a href="https://surge.sh">surge.sh</a> to host this website for free and <a href="https://cloudflare.com">Cloudflare\'s free plan</a> to get an SSL certificate.</p>

<p>When I run the script this is the result I get</p>

<pre><code>➜  bin git:(master) ./send.sh
(✓) Curriculum compilato e copiato.   

Modifiche apportate:
.DS_Store
common/StefanoCadringherIT.pdf
common/n.js
common/style.css
en/.DS_Store
en/src/articles/how-to-build-a-website.md
en/web/.files
en/web/StefanoCadringherEN.pdf
en/web/articles/how-to-build-a-website.html
en/web/n.js
en/web/sitemap.xml
en/web/style.css
it/web/StefanoCadringherIT.pdf
it/web/n.js
it/web/style.css

(✓) Repository aggiornata.    
ac92eda5767baf8a9f13652aa0bf288f893b7dab - Stefano Cadringher


   Running as s.cadringher@nacheso.com (Student)

        project: it/web
         domain: it.cadri.xyz
         upload: [====================] 100% eta: 0.0s (19 files, 2846423 bytes)
            CDN: [====================] 100%

             IP: xxx.xxx.xxx.xxx

   Success! - Published to it.cadri.xyz


   Running as s.cadringher@nacheso.com (Student)

        project: en/web
         domain: en.cadri.xyz
         upload: [====================] 100% eta: 0.0s (20 files, 2851832 bytes)
            CDN: [====================] 100%

             IP: xxx.xxx.xxx.xxx

   Success! - Published to en.cadri.xyz


   Running as s.cadringher@nacheso.com (Student)

        project: default
         domain: cadri.xyz
         upload: [====================] 100% eta: 0.0s (1 files, 70 bytes)
            CDN: [====================] 100%

             IP: xxx.xxx.xxx.xxx

   Success! - Published to cadri.xyz</code></pre>

<p>If you want to learn more, you can <a href="https://gitlab.com/stefano.cadringher/cadri.xyz">take look at my GitLab repository</a> or email me at <a href="mailto:stefano@nacheso.com">stefano@nacheso.com</a></p>
<div class="footer">
	<div class="menuitem"> 
		<a class="m" href="https://it.cadringher.dev">🇮🇹 in Italiano</a> 
		<a class="m nm" style="cursor: pointer;"onclick="toggleNightMode()">✨ Night mode</a> 
	</div>
	<br><br>
	&copy; <a href="contacts.html">Stefano Cadringher</a> @ Nacheso Software, 2022 &mdash; VAT: (IT)11328220964<br>
	Powered by a modified version of <a href="https://www.romanzolotarev.com">Roman Zolotarev's</a> <a href="https://www.romanzolotarev.com/ssg.html">ssg5</a>
</div>
